# MessageType 5

import sqlite3 as lite
import sys
from Ship import Ship
from holtrop3 import Holtrop
from collections import Counter
import time
import datetime


def getShipMessage5(databasepath, MMSI, length):
    con = lite.connect(databasepath)
    messagetype = ("MessageType1", "MessageType2", "MessageType3", "MessageType4", "MessageType5",)

    # for x in messagetype[:1]:
    mmsi = MMSI
    table = messagetype[4]

    # print table
    with con:
        curstring = 'select t1.* from MessageType5 t1 where t1.userid={userid} and (t1.dim_bow+t1.dim_stern)={length}'

        cur = con.execute(curstring.format(userid=mmsi, length=length))
        row = cur.fetchone()
        x = row
        ship = Ship(x[17])

        # Unixtime
        unixtime = x[0]

        # Callsign
        ship.callsign = x[1]
        callsign = x[1]

        # Destination
        destination = x[2]

        # Length
        length = x[3] + x[6]
        ship.length = length

        # Breadth
        breadth = x[4] + x[5]
        ship.breadth = breadth
        if (ship.breadth + 0.01) / (ship.length + 0.01) > 0.5:
            ship.status = "rejected"
            ship.statusDescription = "Ship breadth more than 0.5x length"
            return ship
        draught = x[7]


        curstring = 'SELECT AVG (draught) FROM ' + table + ' where draught>0 and userid = {userid}'
        cur = con.execute(curstring.format(userid=mmsi))
        row = cur.fetchone()

        draught = row[0]
        if row[0] == 0 or row[0] == None:
            ship.status = "rejected"
            ship.statusDescription = "Ship has no draught"
            return ship
        ship.draught = draught / 10.0

        curstring = 'SELECT MAX (draught) FROM ' + table + ' where draught>0 and userid = {userid}'
        cur = con.execute(curstring.format(userid=mmsi))
        row = cur.fetchone()
        maxdraught = row[0]
        if maxdraught == 0 or maxdraught == None:
            ship.status = "rejected"
            ship.statusDescription = "Ship has no draught"
            return ship
        ship.maxdraught = maxdraught / 10.0

        curstring = 'SELECT MIN (draught) FROM ' + table + ' where draught>0 and userid = {userid}'
        cur = con.execute(curstring.format(userid=mmsi))
        row = cur.fetchone()
        mindraught = row[0]

        if mindraught == 0 or mindraught == None:
            ship.status = "rejected"
            ship.statusDescription = "Ship has no draught"
            return ship
        ship.mindraught = mindraught / 10.0

        # Dte
        dte = x[8]

        # eta
        eta = x[9]

        # IMO
        ship.imo = x[10]
        imo = x[10]


        # msgid
        ship.msgid = x[11]
        msgid = x[11]

        # Name
        ship.name = x[12]
        name = x[12]

        # Pos_Type
        ship.postype = x[13]
        postype = x[13]

        # Repeat
        repeat = x[14]

        # Ship type
        ship.shiptype = x[15]
        shiptype = x[15]

        # Spare
        spare = x[16]

        # Userid / MMSI
        userid = x[17]

        # Version
        version = x[18]



        curstring = 'SELECT max(sog) FROM MessageType1 where userid = {userid}'
        # print curstring
        cur = con.execute(curstring.format(userid=mmsi))
        row = cur.fetchone()
        #   print row
        maxspeed = row[0]

        curstring = 'SELECT max(sog) FROM MessageType2 where userid = {userid}'
        #  print curstring
        cur = con.execute(curstring.format(userid=mmsi))
        row = cur.fetchone()
        if row[0] > maxspeed:
            maxspeed = row[0]
        curstring = 'SELECT max(sog) FROM MessageType3 where userid = {userid}'
        cur = con.execute(curstring.format(userid=mmsi))
        row = cur.fetchone()
        if row[0] > maxspeed:
            maxspeed = row[0]

        if maxspeed == None:
            ship.status = "rejected"
            ship.statusDescription = "Ship has no speed records"
            return ship
        maxspeed = maxspeed / 10.0
        ship.maxspeed = maxspeed

        curstring = 'SELECT sum(sog),count(*) FROM MessageType1 where userid = {userid}'
        cur = con.execute(curstring.format(userid=mmsi))
        m1 = cur.fetchone()
        curstring = 'SELECT sum(sog),count(*) FROM MessageType2 where userid = {userid}'
        cur = con.execute(curstring.format(userid=mmsi))
        m2 = cur.fetchone()
        curstring = 'SELECT sum(sog),count(*) FROM MessageType3 where userid = {userid}'
        cur = con.execute(curstring.format(userid=mmsi))
        m3 = cur.fetchone()
        # print m1
        # print m2
        # print m3
        if (m1[0] == None and m2[0] == None and m3[0] == None):
            ship.status = "rejected"
            ship.statusDescription = "Ship has no speed records"
            return ship
        else:
            numRecords = 0
            sumSpeed = 0
            if (m1[0] <> None):
                sumSpeed += m1[0]
                numRecords += m1[1]
            if (m2[0] <> None):
                sumSpeed += m2[0]
                numRecords += m2[1]
            if (m3[0] <> None):
                sumSpeed += m3[0]
                numRecords += m3[1]
            avgspeed = sumSpeed / numRecords
            avgspeed = avgspeed / 10.0
            ship.avgspeed = avgspeed

        # LNG Ships
        if ship.maxdraught <= 13.0 and ship.deltadraught <= 3.5 and ship.maxspeed >= 16.0 and shiptype >= 80 and \
                        shiptype <= 89 and ship.breadth > 0:
            ship.cb = 0.72
            ship.sfc = 215.0
            ship.noeff = 0.65
            ship.shiptypegroup = "LNG carrier"
            # General group
            if ship.breadth >= 40 and ship.breadth <= 52 and ship.length >= 270 and ship.length <= 300:
                ship.shiptypename = "General group"
            # Q-Flex
            elif ship.breadth >= 48 and ship.breadth <= 50 and ship.length >= 314 and ship.length <= 316:
                ship.shiptypename = "Q-Flex"
            # Q-Max
            elif ship.breadth >= 46 and ship.breadth <= 54 and ship.length >= 344 and ship.length <= 345:
                ship.shiptypename = "Q-Max"
            # No match
            else:
                ship.shiptypename = "None of the above LNG ship size"

        # Container ships
        elif ship.maxspeed >= 15.9 and shiptype >= 70 and shiptype <= 79 and ship.breadth > 0:
            ship.cb = 0.60
            ship.sfc = 208.0
            ship.noeff = 0.65
            ship.shiptypegroup = "Container ship"

            # Panamax Container Vessels 1
            if ship.breadth >= 31 and ship.breadth <= 33.0 and ship.length >= 210.0 and ship.length <= 269.9 and \
                            ship.maxdraught <= 10.0 and ship.maxdraught <= 13.0 and ship.deltadraught <= 5.5:
                ship.shiptypename = "Panamax Container Vessels 1"
            # Panamax Container Vessels 2
            elif ship.breadth >= 31 and ship.breadth <= 33.0 and ship.length >= 270.0 and ship.length <= 300.0 and \
                            ship.maxdraught >= 11.0 and ship.maxdraught <= 14.0 and ship.deltadraught <= 5.5:
                ship.shiptypename = "Panamax Container Vessels 2"
            # Post Panamax Container Vessels
            elif ship.breadth >= 40 and ship.breadth <= 43 and ship.length >= 270 and ship.length <= 315 and \
                            ship.deltadraught <= 5.5:
                ship.shiptypename = "Post Panamax Container Vessels"
            # New Panamax Container Vessels
            elif ship.breadth >= 46 and ship.breadth <= 52 and ship.length >= 320 and ship.length <= 370 and \
                            ship.deltadraught <= 5.5:
                ship.shiptypename = "New Panamax Container Vessels"
            # Post New Panamax Container Vessels
            elif ship.breadth >= 54 and ship.breadth <= 58 and ship.length >= 380 and ship.length <= 397 and \
                            ship.deltadraught <= 5.5:
                ship.shiptypename = "Post New Panamax Container Vessels"
            # Trippel E Container Vessels
            elif ship.breadth >= 58 and ship.breadth <= 61 and ship.length >= 397 and ship.length <= 401 and \
                            ship.deltadraught <= 5.5:
                ship.shiptypename = "Trippel E Container Vessels"
            else:
                ship.shiptypename = "None of the above container ship size"

        # Bulk carrier
        elif ship.maxspeed <= 16.0 and shiptype >= 70 and shiptype <= 79 and ship.breadth > 0:
            ship.cb = 0.825
            ship.sfc = 197.0
            ship.noeff = 0.65
            ship.shiptypegroup = "Bulk carrier"

            if ship.breadth >= 30 and ship.breadth <= 34 and ship.length >= 180 and ship.length <= 250 and \
                            ship.mindraught >= 5.0 and ship.deltadraught >= 5.5:
                ship.shiptypename = "Panamax Bulk Carrier"
            elif ship.breadth >= 36 and ship.breadth <= 50 and ship.length >= 230 and ship.length <= 320 and \
                            ship.deltadraught >= 5.0 and ship.maxspeed <= 15.0:
                ship.shiptypename = "Capsize"
            elif ship.breadth >= 29 and ship.breadth <= 33 and ship.length >= 160 and ship.length <= 180 and \
                            ship.deltadraught >= 5.0 and ship.maxspeed <= 15.0:
                ship.shiptypename = "Handymax"
            elif ship.breadth >= 20 and ship.breadth <= 29 and ship.length >= 130 and ship.length <= 180 and \
                            ship.deltadraught >= 5.0 and ship.maxspeed <= 15.0:
                ship.shiptypename = "Handysize"
            else:
                ship.shiptypename = "None of the above bulk carrier size"

        # Oil tanker
        elif ship.maxspeed <= 18.0 and shiptype >= 80 and shiptype <= 89:
            ship.cb = 0.825
            ship.sfc = 210.0
            ship.noeff = 0.58
            ship.shiptypegroup = "Oil Tanker"

            # ULCC & VLCC
            if ship.breadth >= 50 and ship.breadth <= 70 and ship.length >= 320 and ship.length <= 400 and \
                            ship.maxdraught <= 25.0 and ship.mindraught >= 10.0 and ship.deltadraught >= 8.0:
                ship.shiptypename = "ULCC & VLCC"
            # Suezmax
            elif ship.breadth >= 45 and ship.breadth <= 50 and ship.length >= 265 and ship.length <= 320 and \
                            ship.deltadraught >= 5 and ship.draught <= 20.0:
                ship.shiptypename = "Suezmax"
            # Aframax
            elif ship.breadth >= 38 and ship.breadth <= 44 and ship.length >= 235 and ship.length <= 265 and \
                            ship.deltadraught >= 0.0:
                ship.shiptypename = "Aframax"
            # Panamax Oil Tanker
            elif ship.breadth >= 30 and ship.breadth <= 33.5 and ship.length >= 200 and ship.length <= 235 and \
                            ship.deltadraught >= 4.0:
                ship.shiptypename = "Panamax Oil Tanker"
            else:
                ship.shiptypename = "None of the above Oil tankers size"
        else:
            ship.shiptypegroup = "Type: Ship outside ship groups. Not matching ship contraints"
            if ship.length < 100:
                ship.status = "rejected"
                ship.statusDescription = "Ship length < 100m"
                return ship
            else:
                ship.status = "rejected"
                ship.statusDescription = "Ship outside ship groups. Not matching ship contraints. Ship reports length above 100 m"
                return ship


        # Test to reject vessels with faulty AIS information
        if ship.length == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.length == None"
            return ship

        if ship.lpp == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.lpp == None"
            return ship
        if ship.breadth == None or ship.breadth == 0:
            ship.status = "rejected"
            ship.statusDescription = "ship.breadth == " + str(ship.breadth)
            return ship
        if ship.shiptype == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.shiptype == None"
            return ship
        if ship.displacement == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.displacement == None"
            return ship
        if ship.draught == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.draught == None"
            return ship
        if ship.maxdraught == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.maxdraught == None"
            return ship

        if ship.mindraught == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.mindraught == None"
            return ship
        if ship.maxspeed == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.maxspeed == None"
            return ship
        if ship.avgspeed == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.avgspeed == None"
            return ship
        if ship.shiptypegroup == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.shiptypegroup == None"
            return ship

        if ship.cb == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.cb == None"
            return ship

        if ship.sfc == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.sfc == None"
            return ship

        if ship.longcofb == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.longcofb == None"
            return ship
        if ship.transbulbarea == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.transbulbarea == None"
            return ship
        if ship.cobkeel == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.cobkeel == None"
            return ship
        if ship.cm == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.cm == None"
            return ship
        if ship.cwp == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.cwp == None"
            return ship
        if ship.transom == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.transom == None"
            return ship
        if ship.sapp == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.sapp == None"
            return ship
        if ship.sternparameter == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.sternparameter == None"
            return ship
        if ship.propdiameter == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.propdiameter == None"
            return ship
        if ship.numberOfPropellerBlades == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.numberOfPropellerBlades == None"
            return ship
        if ship.propellerClearance == None:
            ship.status = "rejected"
            ship.statusDescription = "ship.propellerClearance == None"
            return ship

        if ship.totalconsumption > 90000:
            ship.status = "rejected"
            ship.statusDescription = "Total consumption way to high, something's wrong!"
            return ship

        curstring = 'SELECT distinct sog FROM MessageType1 where userid = {userid} and sog > 0 ORDER BY sog'
        cur = con.execute(curstring.format(userid=mmsi))
        rows = cur.fetchall()
        curstring = 'SELECT distinct sog FROM MessageType2 where userid = {userid} and sog > 0 ORDER BY sog'
        cur = con.execute(curstring.format(userid=mmsi))
        rows += cur.fetchall()
        curstring = 'SELECT distinct sog FROM MessageType3 where userid = {userid} and sog > 0 ORDER BY sog'
        cur = con.execute(curstring.format(userid=mmsi))
        rows += cur.fetchall()

        speeds = set(rows)

        hm = Holtrop(ship, speeds)
        pb = hm.getBrakePowers()
        ship.pb = pb

        curstring = 'SELECT unixtime,sog FROM MessageType1 where userid = {userid} ORDER BY unixtime'
        cur = con.execute(curstring.format(userid=mmsi))
        rows = cur.fetchall()

        curstring = 'SELECT unixtime,sog FROM MessageType2 where userid = {userid} ORDER BY unixtime'
        cur2 = con.execute(curstring.format(userid=mmsi))
        rows += cur2.fetchall()

        curstring = 'SELECT unixtime,sog FROM MessageType3 where userid = {userid} ORDER BY unixtime'
        cur3 = con.execute(curstring.format(userid=mmsi))
        rows += cur3.fetchall()
        rows.sort()

        speed = None
        time = None
        totalconsumption = 0.0
        total_days = 0
        ship.numSpeedRecords = len(rows)
        for row in rows:
            if speed != None and speed > 0:
                timespan = row[0] - time
                target = speed / 10.0
                if target > 5:  # Record sea days
                    total_days += timespan

                power = pb[target]

                if timespan == 0:
                    totalconsumption = totalconsumption
                elif target < 30:
                    stepconsumption = (ship.sfc / 1000000) * (timespan / 3600) * power
                    totalconsumption += stepconsumption

            speed = row[1]
            time = row[0]
        ship.totalconsumption = totalconsumption
        ship.totalSailingDays = total_days / (3600.0 * 24.0)
        ship.status = "success"
        ship.statusDescription = "Ship consumption calculated without any errors"
        return ship
