#Main
import MessageType5
import sqlite3 as lite
import time
from tqdm import tqdm
import datetime

from timeit import default_timer as timer

from Ship import Ship

global allconsumption
allconsumption=0
co2emission = 0
ch4emission = 0
n20emission = 0
noxemission = 0
nmvocemission = 0
coemission = 0
pmemission = 0
so2emission = 0

global mmsi

global databasepath
databasepath="data/masterdatabase1.db"
#databasepath="data/masterdatabase_reduced.db"

if __name__ == '__main__':
    ships=[]
    con = lite.connect(databasepath)
    rejected_ships = 0
    count =0

    with con:
        curstring = 'select distinct t.userid, (t.dim_bow + t.dim_stern) from ' \
                    '(select t1.* from MessageType5 t1 inner join ' \
                    '(select userid, min(dim_stern+dim_bow) minlength from MessageType5 group by userid) t2 ' \
                    'on (t1.userid=t2.userid and  (t1.dim_bow+t1.dim_stern)=t2.minlength) ' \
                    'where (t1.dim_bow+t1.dim_stern)>=130 and ' \
                    '(t1.dim_bow+t1.dim_stern)<460 and ' \
                    't1.ship_type<100 and ' \
                    'LENGTH(t1.imo)=7 and ' \
                    'LENGTH(t1.userid)=9) t'

        cur = con.execute(curstring)

        rows = cur.fetchall()
        bar = tqdm(total=len(rows))

        for row in rows:

            ship=MessageType5.getShipMessage5(databasepath,row[0],row[1])
            if ship.status == "rejected":
                ships.append(ship)
                rejected_ships += 1
            else:
                ships.append(ship)
                allconsumption += ship.totalconsumption
                co2emission += ship.co2emission
                ch4emission += ship.ch4emission
                n20emission += ship.n20emission
                noxemission += ship.noxemission
                nmvocemission += ship.nmvocemission
                coemission += ship.coemission
                pmemission += ship.pmemission
                so2emission += ship.so2emission
                count =count+1
            bar.update(1)


    bar.write("[" + str(count) + "/" + str(rejected_ships) + "]")
    print "Total rejects",rejected_ships
    print "Total ships calculated " ,count
    print "Consumption for all ships within limits: ", allconsumption
    print "Final consumption: ", allconsumption
    print "Total CO2 emission ",  co2emission
    print "Total CH4 emission ",  ch4emission
    print "Total N20 emission ",  n20emission
    print "Total NOx emission ",  noxemission
    print "Total NMVOC emission ",  nmvocemission
    print "Total CO emission ",  coemission
    print "Total PM emission ", pmemission
    print "Total SO2 emission ",  so2emission
    dateString = datetime.datetime.strftime(datetime.datetime.now(), '%Y-%m-%d %H:%M:%S')
    f = open('output/output['+dateString+'].csv', 'w')
    f.write(ships[0].getCsvHeader()+"\n")
    for ship in ships:
        f.write(ship.getCSV()+"\n")
    f.close()

